--- a/test/libapt/run-tests
+++ b/test/libapt/run-tests
@@ -8,6 +8,16 @@
 LDPATH="$DIR/../../build/bin"
 EXT="_libapt_test"
 
+custom_dmesg() {
+	if `which dmesg`; then
+		dmesg
+	elif [ -r /var/log/dmesg ]; then
+		cat /var/log/dmesg
+	else
+		printf ""
+	fi
+}
+
 # detect if output is on a terminal (colorful) or better not
 if expr match "$(readlink -f /proc/$$/fd/1)" '/dev/pts/[0-9]\+' > /dev/null; then
 	COLHIGH='\033[1;35m'
@@ -68,7 +78,7 @@
 			"${tmppath}/ftp.de.debian.org_debian_dists_sid_main_i18n_Translation-ast_DE"
 	elif [ $name = "HashSums${EXT}" ]; then
 		TMP="$(mktemp)"
-		dmesg > $TMP
+		custom_dmesg > $TMP
 		echo -n "Testing with \033[1;35m${name}\033[0m ... "
 		LD_LIBRARY_PATH=${LDPATH} ${testapp} $TMP $(md5sum $TMP | cut -d' ' -f 1) $(sha1sum $TMP | cut -d' ' -f 1) $(sha256sum $TMP | cut -d' ' -f 1) $(sha512sum $TMP | cut -d' ' -f 1) && echo "\033[1;32mOKAY\033[0m" || echo "\033[1;31mFAILED\033[0m"
 		rm $TMP
